//+------------------------------------------------------------------+
//|                                                  Mashkauskas.mq4 |
//|                                        Copyright  2010, Avatara |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Avatara"
#property link      "Avatara@bigmir.net"
#define PRINT_CARR                       "\n"
//+------------------------------------------------------------------+
extern bool Revers=true;
extern int Max_Orders=12, Tolerance=2,K33=33;
extern int iMAFastPeriod = 25;
extern int iMAFastShift  = 0;
extern int iMAFastMetod  = 0;
extern int iMAFastPrice  = 0;
extern int iMASlowPeriod = 200;
extern int iMASlowShift  = 0;
extern int iMASlowMetod  = 0;
extern int iMASlowPrice  = 0;
extern bool Invert=true;
double MBalls [13];
int    MBallsPips[13]; 
extern int SlipPage   = 2;
extern double Lufert   = 0.001;
extern double Luft   = 0.0025;
extern double Lots   = 0.1;
extern double TakeProfit   = 0.07;
extern double SLoss   = 0.07,ProfDreams=15;
double ZZ=0.0,MaxSell,MinSell,MinBuy,MaxBuy; 
int K_Buy,K_Sell,i, totals;
static datetime LastTimeBar ;

//+------------------------------------------------------------------+
int init() {
  LastTimeBar = D'01.01.2000 00:00:00';
  MBalls [0]=0; 
  MBalls [1]=1; MBalls [2]=2; MBalls [3]=3; MBalls [4]=5;MBalls [5]=7;
  MBalls [6]=11; MBalls [7]=25; MBalls [8]=33;MBalls [9]=44;
  MBalls [10]=77;MBalls [11]=111;MBalls [12]=222;
  MBallsPips[0]=0; MBallsPips[1]=5; MBallsPips[2]=10;
  MBallsPips[3]=17; MBallsPips[4]=25; MBallsPips[5]=33;
  MBallsPips[6]=37; MBallsPips[7]=77; MBallsPips[8]=44;
  MBallsPips[9]=4; MBallsPips[10]=-10;MBallsPips[11]=11;
  MBallsPips[12]=21;
  for (i=100;i>=0;i--)
  if (iCustom(Symbol(),0,"ZigZag",K33,1,3,0,0)>0.0) 
      ZZ=iCustom(Symbol(),0,"ZigZag",K33,1,3,0,0);   
  return(0);
}

//+------------------------------------------------------------------+
int deinit() {
  return(0);
}

//+------------------------------------------------------------------+
int start() {
  
  if (LastTimeBar < Time[0]) {
    LastTimeBar = Time[0];
    DoAnalysis();
  }
  return(0);
}
//+------------------------------------------------------------------+

void DoAnalysis() {
  double dZZ=iCustom(Symbol(),0,"ZigZag",K33,1,3,0,0);
       if (dZZ!=0) {ZZ=dZZ;i=Info_on_Orders(false);}
  double DeltaMA = iMA(Symbol(), 0, iMAFastPeriod,
                       iMAFastShift, iMAFastMetod, iMAFastPrice, 1) - 
                   iMA(Symbol(), 0, iMASlowPeriod,
                       iMASlowShift, iMASlowMetod, iMASlowPrice, 1);
  if (MathAbs(DeltaMA)<=Lufert)
  { i=Info_on_Orders(false);
    if (Open[0]>=ZZ+Luft && ZZ<iMA(Symbol(), 0, iMASlowPeriod,
                         iMASlowShift, iMASlowMetod, iMASlowPrice, 1))
      if (Invert)   DoSell();
        else DoBuy(); 
     else if (Open[0]<=ZZ-Luft && ZZ>iMA(Symbol(), 0, iMASlowPeriod,
                         iMASlowShift, iMASlowMetod, iMASlowPrice, 1))
      if (Invert)   DoBuy();
        else DoSell(); 
  }    
}  
//+------------------------------------------------------------------+
//
//+------------------------------------------------------------------+

void DoBuy() {
  bool IsOrderClose, IsBuyOrderExist = true;

  if (Revers)  for (int iOrder = OrdersTotal() - 1; iOrder >= 0; iOrder--) 
   {
    if (OrderSelect(iOrder, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol())
    {           
        if (OrderType() == OP_SELL)
       if (OrderProfit()>ProfDreams*MBalls[K_Sell])  
       if(!OrderClose(OrderTicket(), OrderLots(),ND(Ask), SlipPage))
          Print("Error SELL close ",GetLastError());      
    }
  }
 if (K_Buy<=Max_Orders && Ask<=MinBuy-MBallsPips[K_Buy]*Point){
 
       i=OrderSend(Symbol(),OP_BUY,NormalizeDouble(Lots+MBalls[K_Buy]*Lots,Tolerance),
                ND(Ask),SlipPage,ND(Bid-SLoss),ND(Ask+TakeProfit),
                "Mahea&33 "+Period()+K_Buy+" "+ZZ,77333,0,Green);
   
         if(i>0)
           {
             Print("BUY order opened ");
           }
         else Print(" Error opening BUY order : ",GetLastError());
    }      
       
}
//+------------------------------------------------------------------+
void DoSell() {
  if (Revers) for (int iOrder = OrdersTotal() - 1; iOrder >= 0; iOrder--) {
    if (OrderSelect(iOrder, SELECT_BY_POS, MODE_TRADES)
         && OrderSymbol() == Symbol())
    { 
     if (OrderType() == OP_BUY)         
     if (OrderProfit()>ProfDreams*MBalls[K_Buy])
     if(!OrderClose(OrderTicket(), OrderLots(), ND(Bid), SlipPage)) 
                       Print("Error BUY close ",GetLastError());
    }
  }
 if (K_Sell<=Max_Orders && Bid>=MaxSell+MBallsPips[K_Sell]*Point)
  {
       i=OrderSend(Symbol(),OP_SELL,
                NormalizeDouble(Lots+MBalls[K_Sell]*Lots,Tolerance),
                ND(Bid),SlipPage,ND(Ask+SLoss),ND(Bid-TakeProfit),
                "Mahea&&33 "+Period()+K_Sell+" "+ZZ,77333,0,Blue);
       if(i>0)Print("Sell order opened ");
         else Print(" Error opening Sell order : ",GetLastError()); 
  }
}
//+------------------------------------------------------------------+
//
//+------------------------------------------------------------------+
int Info_on_Orders(bool Prin)
  {double min=9999999,min1,max=0,max1,MaxBuy1=0.0,MinSell1=999999; 
  int cnt = OrdersTotal(),KS=0,KB=0;string str1;
  for (int i=cnt-1; i >= 0; i--)
   {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    //if (OrderMagicNumber() != Magic) continue;
    if (OrderType() == OP_SELL) 
      { max1=OrderOpenPrice();KS=KS+1;
       if (max1>max) max=max1;
       if (max1<MinSell1) MinSell1=max1;
       }
    else if (OrderType() == OP_BUY)
      { min1=OrderOpenPrice();KB=KB+1;
       if  (min1<min) min=min1;
       if (min1>MaxBuy1) MaxBuy1=min1; 
      }
   }
   MaxSell=max;
   if (KS>0) MinSell=MinSell1;
               else {MinSell=Ask;MaxSell=Bid;}                          
   MinBuy=min; if (KB>0) MaxBuy=MaxBuy1;
               else {MaxBuy=Bid;MinBuy=Ask;}
   K_Buy=KB;
   K_Sell=KS;KS=0;KB=0;min=9999999.0;max=0.0;
 str1=StringConcatenate(PRINT_CARR,
 "         Margin= ",NormalizeDouble(AccountMargin( ),0),"  Z=",ZZ,PRINT_CARR,
 "         Markets=",Ask," / ", Bid," (",(Ask-Bid)/Point,")",PRINT_CARR,
 "         MS(",K_Sell,"}=",MaxSell,"   :   ",MinSell,
                     " (",(MaxSell-MinSell)/Point,")", PRINT_CARR,PRINT_CARR);
 str1=StringConcatenate(str1,           
 "         MB(",K_Buy,"}=",MaxBuy,"  : ",
       MinBuy,"     (",(MaxBuy-MinBuy)/Point,")",PRINT_CARR);                                         
    Comment (str1);
    if (Prin) Print (str1); 
   return(0);
  }
//+------------------------------------------------------------------+
double ND (double v)
 {  
  return(NormalizeDouble(v,Digits));
 }
//-------------------------------------------------------------------

